(*
** Definition of SNORM 
*)

(*
mu[SN:Tm->Set](
  SNi : {M:Tm}({N:Tm}(Step M N)->(SN N))->(SN M))
*)

$[SN:Tm->Set]
$[SNi : {M:Tm}({N:Tm}(Step M N)->(SN N))->(SN M)]
$[RecSN : {P:{M|Tm}(SN M)->Type}
	({M:Tm}{F:{N:Tm}(Step M N)->(SN N)}
		({N:Tm}{R:Step M N}P (F N R))
		-> (P (SNi M F)))
	-> {M|Tm}{p:SN M}P p];

[RHS_SN[P:{M|Tm}(SN M)->Type]
 [SNi_ : {M:Tm}{F:{N:Tm}(Step M N)->(SN N)}
		({N:Tm}{R:Step M N}P (F N R))
		-> (P (SNi M F))]
 [M:Tm][F:{N:Tm}(Step M N)->(SN N)] =
 SNi_ M F ([N:Tm][R:Step M N]RecSN P SNi_ (F N R))];
		
[[P:{M|Tm}(SN M)->Type]
 [SNi_ : {M:Tm}{F:{N:Tm}(Step M N)->(SN N)}
		({N:Tm}{R:Step M N}P (F N R))
		-> (P (SNi M F))]
 [M:Tm][F:{N:Tm}(Step M N)->(SN N)]
   RecSN P SNi_ (SNi M F) ==> 
(* 	SNi_ M F ([N:Tm][R:Step M N]RecSN P SNi_ (F N R)) *)
	RHS_SN P SNi_ M F];

[RecSNN [P:Tm->Type] = RecSN ([M|Tm][_:SN M]P M)
	: ({M:Tm}({N:Tm}(Step M N)->SN N)->({N:Tm}(Step M N)->P N)->P M)
	  ->{M|Tm}(SN M)->P M];

(* lemmas about SN *)

Goal {M|Tm}(SN M)->{N:Tm}(Step M N)->(SN N);
intros M sn_M;
Refine RecSNN ([M:Tm]{N:Tm}(Step M N)->(SN N));	
intros;Refine H;Refine H2;
Refine sn_M;
Save SNd;

Goal {M,N|Tm}(SN (app M N)) -> (SN M);
Intros;
Claim {MN|Tm}(SN MN)->{M,N|Tm}(EQ MN (app M N)) -> (SN M);
Refine ?+1;Next +1;Refine H;Next +1;Refine EQ_refl;
Refine RecSNN [MN|Tm]{M,N|Tm}(EQ MN (app M N))->SN M;
intros;Refine SNi;intros;Refine H2;
Next +1;Refine EQ_rewrite' H3 ([M:Tm]Step M ?+1);
Refine app_l;Next +1;Refine H4;Next +1;Refine EQ_refl;
Save SNapp;

Goal {M|Tm}{n:Nat}(SN (subst0 M (var n)))->(SN M);
intros;
Refine RecSNN [M':Tm]{M:Tm}(EQ M' (subst0 M (var n)))->(SN M);
intros;Refine SNi;intros;Refine H2;Next +2;Refine EQ_refl;
Refine EQ_rewrite' H3 ([X:Tm]Step X ?);Refine step_subst;
Refine H4;
(**)
Next +1;Refine H;Refine EQ_refl;
Save SNvar;

(*
** Definition of Candidates
*)

[neutr[M:Tm] = {M':Tm}not (EQ (lam M') M)];

[P:Tm -> Set]

[CR1 = {M|Tm}(P M)->(SN M)]
[CR2 = {M|Tm}(P M)->{N:Tm}(Step M N)->(P N)]
[CR3 = {M|Tm}(neutr M)->
	 ({N:Tm}(Step M N)->(P N))->(P M)]
[CR = CR1 /\ CR2 /\ CR3];
		
Discharge P;

(* 
** Candidates contain all variables
*)

Goal {P:Tm->Set}(CR P)->{i:Nat}P (var i);
Intros;
Refine snd (snd H);
(* neutral *)
Refine neq_var_lam;
(* is in nf *)
Intros;Refine nf_var;Next +2;Refine H1;
Save CR_nonEmpty;

(*
** SN is a candidate
*)

Goal CR SN;
andI;
Intros;Immed;
andI;
Intros;Refine SNd;Immed;
Intros;Refine SNi;Refine H1;
Save CR_SN;

(*
** ARR preserves candidates
*)

[ARR[P,R:Tm->Set] = [M:Tm]{N:Tm}(P N)->(R (app M N))];

Goal {P,R:Tm->Set}(CR P)->(CR R)->(CR (ARR P R));
intros P R CR_P CR_R;andI;
(* CR1 *)
Intros M H;Refine SNapp;Refine var zero;
Refine fst CR_R;Refine H;Refine CR_nonEmpty;Refine CR_P;
andI;
(* CR2 *)
Intros M H1 N H2 N1 H3;
Refine fst (snd CR_R);Next +2;Refine app_l;Next +1;Refine H2;
Refine H1;Refine H3;
(* CR3 *)
Intros M nM Hyp N P_N;
Refine snd(snd CR_R);
Intros _;Refine neq_lam_app;
Claim (P N)->{L:Tm}(Step (app M N) L)->(R L);
Refine ?+1;Refine P_N;
Refine RecSNN [N:Tm](P N)->{L:Tm}(Step (app M N) L)->R L;
intros N' _ IH P_N' L H1;
Claim {MN':Tm}(EQ MN' (app M N'))->(R L);
Refine ?+1;Next +1;Refine EQ_refl;Intros MN' EQ_MN';
Refine RecStepN [MN',L:Tm](EQ MN' (app M N'))->R L;
(* impossible *)
intros;Refine inj_app;Next +4;Refine H2;intros;Refine nM;
Next +1;Refine H3;
(* M was reduced *)
intros;Refine inj_app;Next +4;Refine H4;intros;
Refine Hyp;
Refine EQ_rewrite H5 ([M:Tm]Step M M');Refine H2;
Refine EQ_rewrite' H6 P;Refine P_N';
(* N was reduced *)
intros;Refine inj_app;Next +4;Refine H4;intros;
Refine snd (snd CR_R);Intros _;Refine neq_lam_app;
intros;Refine IH;Refine M';Refine EQ_rewrite H6 ([N':Tm]Step N' M');
Refine H2;Refine fst(snd CR_P);Refine N';Refine P_N';
Refine EQ_rewrite H6 ([N':Tm]Step N' M');Refine H2;
Refine EQ_rewrite H5 ([M:Tm]Step (app M M') N2);Refine H7;
(* impossible *)
intros;Refine neq_lam_app;Next +3;Refine H4;
(* end of cases *)
Next +1;Refine H1;Refine EQ_refl;
(* SN N *)
Refine fst (CR_P); Refine P_N;
Save CR_ARR;

(*
** Soundness of Lam
*)

Goal {P,R:Tm->Set}(CR P)->(CR R)->{M:Tm}
	({N:Tm}(P N)->(R (subst0 M N)))
	->(ARR P R (lam M));
Intros P R CR_P CR_R M H L P_L;
Refine RecSNN [M:Tm]{L:Tm}(P L)->
	({N:Tm}(P N)->R (subst0 M N))->R (app (lam M) L);
intros M1 _ IH1 L1 P_L1 Hyp; 
Refine RecSNN [L:Tm](P L)->(R (app (lam M1) L));
intros L2 _ IH2 P_L2;
(* Apply CR3 for R *)
Refine snd(snd CR_R);Intros _;Refine neq_lam_app;intros MM _;
(* Induction over Step *)
Refine RecStepN [lam_M1_L2,MM:Tm](EQ lam_M1_L2 (app (lam M1) L2))->(R MM);
(** beta **)
intros M1' L2' _;Refine inj_app;Next +4;Refine H4;intros;
Refine EQ_rewrite' ? ([X:Tm]R (subst0 X L2'));Next +1;
Refine inj_lam;Refine H5;Refine EQ_rewrite' H6 ([X:Tm]R (subst0 M1 X));
Refine Hyp;Refine P_L2;
(** app_l **)
intros lam_M1 lam_M1' L3 ___;Refine inj_app;Next +4;Refine H6;intros;
Refine step_lam;Next +2;Refine EQ_rewrite H7 ([X:Tm]Step X ?+2);Refine H4;
intros M1' _;Refine H9;intros;
Refine EQ_rewrite' H11 ([X:Tm]R (app X L3));
Refine IH1;Refine H10;Refine EQ_rewrite' H8 P;Refine P_L2;
intros;Refine fst (snd CR_R);Next +2;Refine step_subst;Next +1;Refine H10;
Refine Hyp;Refine H12;
(** app_r **)
intros L3 L3' lam_M2 ___;Refine inj_app;Next +4;Refine H6;intros;
Refine EQ_rewrite' H7 ([X:Tm]R (app X L3'));
Refine IH2;
Next +1;Refine fst (snd CR_P);Next +1;Refine P_L2;Refine ?+1;
Refine EQ_rewrite H8 ([X:Tm]Step X L3');Refine H4;
(** xi - impossible **)
intros;Refine neq_lam_app;Next +3;Refine H6;
(** END of CASES **)
Next +1; Refine H3; Refine EQ_refl;
Refine fst CR_P;Immed;
(* SN_M *) Refine SNvar zero;Refine fst CR_R;Refine H;Refine CR_nonEmpty;
Immed;
Save Lam_sound;

[PI[F:(Tm->Set)->(Tm->Set)] =
	[M:Tm]{P:Tm->Set}(CR P)->(F P M)];

Goal {F:(Tm->Set)->(Tm->Set)}
	({P:Tm->Set}(CR P)->(CR (F P)))
	-> (CR (PI F));
intros;andI;
(* CR1 *) Intros;Refine (fst (H ? ?));Refine SN;Next +1;Refine H1;
Refine ?+1;Refine CR_SN;
andI;
(* CR2 *) Intros;Refine (fst (snd (H P H3)));Next +1;Refine H1;Immed;
(* CR3 *) Intros;Refine (snd (snd (H P H3)));Refine H1;intros;Refine H2;
Immed;
Save CR_PI;
